//
//  AudioViewController.swift
//  VKExt
//
//  Created programmist_NA on 23.05.2020.
//  Copyright © 2020 ___ORGANIZATIONNAME___. All rights reserved.
//
//  Template generated by Juanpe Catalán @JuanpeCMiOS
//

import UIKit
import Material
import MaterialComponents
import SwiftMessages
import RealmSwift
import RxKeyboard
import RxSwift
import KDEAudioPlayer

class AudioViewController: UIBaseTableViewController, UIBaseViewControllerProtocol, UIBaseTableViewControllerProtocol, AudioViewProtocol {
	var presenter: AudioPresenterProtocol?
    var searchController: VKSearchBar = VKSearchBar(frame: CGRect(origin: CGPoint(x: 52, y: getCommonInset(by: [.statusbar])), size: CGSize(width: Screen.bounds.width - 52, height: 52)))
    let activityIndicator = MDCActivityIndicator()
    
    let progressAudioDownload: MDCActivityIndicator = {
        let progressAudioDownload = MDCActivityIndicator()
        progressAudioDownload.radius = 15
        progressAudioDownload.strokeWidth = 5
        progressAudioDownload.indicatorMode = .determinate
        progressAudioDownload.cycleColors = [.extendedRed, .extendedOrange, .extendedGreen, .extendedBlue]
        progressAudioDownload.progress = 0
        return progressAudioDownload
    }()
    var popButton: IconButton = {
        let button = IconButton(image: UIImage(named: "arrow_left_outline_28")?.withRenderingMode(.alwaysTemplate).tint(with: .adaptableBlue), tintColor: .adaptableBlue)
        button.addTarget(self, action: #selector(pop), for: .touchDown)
        return button
    }()
    var extButton: IconButton = {
        let button = IconButton(image: UIImage(named: "more_vertical_28")?.withRenderingMode(.alwaysTemplate).tint(with: .adaptableBlue), tintColor: .adaptableBlue)
        button.addTarget(self, action: #selector(initialFooter), for: .touchDown)
        return button
    }()
    
    var loginView = LoginView(frame: CGRect(origin: .zero, size: CGSize(width: Screen.bounds.width - 24, height: Screen.bounds.height / 2)))
    var isKeyboardShow = false
    var items: [AudioItem] = []
    
    lazy var tabBar: TabBar = {
        let tabBar = TabBar()
        tabBar.tabItems = tabBarItems
        tabBar.translatesAutoresizingMaskIntoConstraints = false
        tabBar.lineColor = .adaptableBlue
        tabBar.line.cornerRadiusPreset = .cornerRadius1
        tabBar.setTabItemsColor(.adaptableBlue, for: .selected)
        tabBar.setTabItemsColor(.adaptableDarkGrayVK, for: .normal)
        tabBar.dividerColor = .clear
        tabBar.tabItems[0].titleLabel?.font = GoogleSansFont.medium(with: 16)
        tabBar.tabItems[1].titleLabel?.font = GoogleSansFont.medium(with: 16)
        return tabBar
    }()
    lazy var tabBarItems: [TabItem] = {
        return zip(itemTitles, itemIcons)
            .enumerated()
            .map { (index, titleIconPair) in
                let (title, icon) = titleIconPair
                return TabItem(title: title)
        }
    }()
    let itemTitles = ["Моя музыка", "Сохраненные"]
    let itemIcons: [UIImage?] = [nil, nil]
    private var audioViewModel = AudioViewModel.init(cells: [], footerTitle: nil)
    private lazy var footerView = FooterView()

	override func viewDidLoad() {
        super.viewDidLoad()
        UIApplication.shared.beginReceivingRemoteControlEvents()
        AudioRouter.createModule(self)
        if let token = UserDefaults.standard.string(forKey: "audioToken"), let secret = UserDefaults.standard.string(forKey: "secret") {
            presenter?.start(token: token, secret: secret, request: .getAudio)
        } else {
            initialFooter()
        }
        initialObservers()
        registerKeyboardNotifications()
        prepareToolbar(fonts: [GoogleSansFont.bold(with: 21), GoogleSansFont.regular(with: 13)])
        prepareTable()
        setupTable()
        initialComponent()
        setupToolbar(title: "", subtitle: "", leftViews: [popButton], rightViews: nil)
        initialError()
    }
    
    override func remoteControlReceived(with event: UIEvent?) {
        if event?.type == .remoteControl {
            switch event!.subtype {
            case .remoteControlPlay :
                VKAudioService.instance.player.play()
            case .remoteControlPause :
                VKAudioService.instance.player.pause()
            case .remoteControlNextTrack :
                VKAudioService.instance.player.playNext()
            case .remoteControlPreviousTrack:
                VKAudioService.instance.player.playPrevious()
            case .remoteControlTogglePlayPause:
                if VKAudioService.instance.player.state == .playing {
                    VKAudioService.instance.player.pause()
                } else {
                    VKAudioService.instance.player.play()
                }
            default:
                break
            }
        }
    }
    
    func initialObservers() {
        NotificationCenter.default.addObserver(self, selector: #selector(willVKSearchBarOpened), name: NSNotification.Name(rawValue: "VKSearchBar.beginEditing"), object: nil)
        NotificationCenter.default.addObserver(self, selector: #selector(willVKSearchBarClosed), name: NSNotification.Name(rawValue: "VKSearchBar.endEditing"), object: nil)
    }
    
    func setupToolbar(title: String, subtitle: String, leftViews: [UIView]?, rightViews: [UIView]?) {
        toolbar.title = title
        toolbar.detail = subtitle
        if let leftViews = leftViews {
            toolbar.leftViews = leftViews
        }
        if let rightViews = rightViews {
            toolbar.rightViews = rightViews
        }
        view.addSubview(searchController)
        searchController.setup(placeholder: "Поиск")
        searchController.textView.delegate = self
    }
    
    func initialComponent() {
        // Progress indicator
        activityIndicator.sizeToFit()
        view.addSubview(activityIndicator)
        activityIndicator.autoCenterInSuperview()
        activityIndicator.radius = 15
        activityIndicator.strokeWidth = 3
        activityIndicator.indicatorMode = .indeterminate
        activityIndicator.cycleColors = [.extendedBlue]
        
        toolbar.addSubview(progressAudioDownload)
        progressAudioDownload.autoPinEdge(.trailing, to: .trailing, of: toolbar, withOffset: -16)
        progressAudioDownload.autoSetDimensions(to: CGSize(width: 32, height: 32))
        progressAudioDownload.isHidden = true
        
        activityIndicator.isHidden = true
        loginView.loginField.delegate = self
        loginView.passwordField.delegate = self
        loginView.loginButton.addTarget(self, action: #selector(login), for: .touchUpInside)
        loginView.dismissButton.addTarget(self, action: #selector(dismissLogin), for: .touchUpInside)
        // Tab bar
        view.addSubview(tabBar)
        tabBar.autoPinEdge(.top, to: .bottom, of: toolbar)
        tabBar.autoPinEdge(.trailing, to: .trailing, of: view, withOffset: -12)
        tabBar.autoPinEdge(.leading, to: .leading, of: view, withOffset: 12)
        tabBar.autoSetDimension(.height, toSize: 46)
    }
    
    func displayData(viewModel: TestAudioItem.Model.ViewModel.ViewModelData) {
        switch viewModel {
        case .displayAudio(audioViewModel: let audioViewModel):
            self.audioViewModel = audioViewModel
            VKAudioService.instance.initPlayer(itemsUrl: audioViewModel.cells.map { URL(string: $0.url)! })
            mainTable.reloadData()
            refreshControl.endRefreshing()
            footerView.setTitle("\(audioViewModel.cells.count) аудио")
        case .displayFooterLoader:
            footerView.setTitle("")
            footerView.showLoader()
        case .displayFooterError(message: let message):
            footerView.setTitle(message)
        }
    }
    
    func setupTable() {
        mainTable.verticalScrollIndicatorInsets.top = 52
        mainTable.contentInset.top = 52
        mainTable.keyboardDismissMode = .onDrag
        mainTable.allowsMultipleSelectionDuringEditing = true
        mainTable.separatorStyle = .none
        mainTable.delegate = self
        mainTable.dataSource = self
        mainTable.tableFooterView = footerView
        mainTable.register(UINib(nibName: "AudioTableViewCell", bundle: nil), forCellReuseIdentifier: "AudioTableViewCell")
        mainTable.register(UINib(nibName: "AudioHeaderTableViewCell", bundle: nil), forCellReuseIdentifier: "AudioHeaderTableViewCell")
        let longPressGestureRecognizer = UILongPressGestureRecognizer(target: self, action: #selector(handleLongPress(_:)))
        longPressGestureRecognizer.minimumPressDuration = 0.25
        mainTable.addGestureRecognizer(longPressGestureRecognizer)
        refreshControl.addTarget(self, action: #selector(refreshTable(_:)), for: UIControl.Event.valueChanged)
    }
    
    @objc func initialFooter() {
        handleLoading(from: true)
        var config = SwiftMessages.Config()
        config.presentationStyle = .center
        config.presentationContext = .viewController(self)
        config.duration = .forever
        config.dimMode = .blur(style: .regular, alpha: 0.95, interactive: true)
        config.interactiveHide = false
        config.preferredStatusBarStyle = .default
        config.eventListeners.append() { event in
            if case .didHide = event {
                self.loginView.loginField.text = ""
                self.loginView.passwordField.text = ""
                self.handleLoading(from: false)
                self.showError(message: """
                Требуется авторизация
                для получения токена
                """, image: UIImage(named: "touch_id_outline_56")!)
            } else if case .willHide = event {
                self.loginView.loginField.resignFirstResponder()
                self.loginView.passwordField.resignFirstResponder()
                UIView.animate(withDuration: 0.3) {
                    self.loginView.containter.transform = .identity
                    self.view.layoutIfNeeded()
                }
            }
        }
        SwiftMessages.show(config: config, view: loginView)
    }
    
    func handleLoading(from isNeed: Bool) {
        if isNeed {
            activityIndicator.isHidden = false
            activityIndicator.startAnimating()
        } else {
            activityIndicator.isHidden = true
            activityIndicator.stopAnimating()
        }
    }
    
    func finish() {
        refreshControl.endRefreshing()
        mainTable.reloadData()
        hideError()
        SwiftMessages.hideAll()
        self.loginView.progress.stopAnimating()
        self.loginView.loginButton.setTitle("Войти", for: .normal)
    }
    
    override func showError(message: String, image: UIImage?) {
        devView.isHidden = false
        mainTable.isHidden = true
        tabBar.isHidden = true
        devView.setup(message: """
        \(message)
        """, image: image)
        self.loginView.loginField.drawBorder(10, width: 1, color: .extendedRed)
        self.loginView.passwordField.drawBorder(10, width: 1, color: .extendedRed)
        self.loginView.loginField.backgroundColor = .adaptableError
        self.loginView.passwordField.backgroundColor = .adaptableError
        self.loginView.progress.stopAnimating()
        self.loginView.loginButton.setTitle("Войти", for: .normal)
    }
    
    override func hideError() {
        devView.isHidden = true
        mainTable.isHidden = false
        tabBar.isHidden = false
    }
    
    func setProgressHidden(from value: Bool, at indexPath: IndexPath) {
        let cell = mainTable.cellForRow(at: indexPath) as! AudioTableViewCell
        cell.setProgressHidden(from: value)
    }
    
    func setProgress(from value: Float, at indexPath: IndexPath) {
        let cell = mainTable.cellForRow(at: indexPath) as! AudioTableViewCell
        cell.setProgress(at: value)
    }
    
    @objc func refreshTable(_ sender: Any?) {
        if let token = UserDefaults.standard.string(forKey: "audioToken"), let secret = UserDefaults.standard.string(forKey: "secret") {
            presenter?.start(token: token, secret: secret, request: .getAudio)
        } else {
            initialFooter()
        }
    }
    
    @objc func dismissLogin(_ sender: Any?) {
        SwiftMessages.hideAll()
    }
    
    @objc func pop(_ sender: Any?) {
        self.navigationController?.popViewController(animated: true)
    }
    
    @objc func login(_ sender: Any?) {
        if !self.loginView.loginField.text!.isEmpty && !self.loginView.passwordField.text!.isEmpty {
            presenter?.onLogin(login: self.loginView.loginField.text!, password: self.loginView.passwordField.text!)
            self.loginView.progress.startAnimating()
            self.loginView.loginButton.setTitle("", for: .normal)
        }
    }
    
    @objc func handleLongPress(_ gestureRecognizer: UILongPressGestureRecognizer?) {
        guard let point = gestureRecognizer?.location(in: self.mainTable) else { return }
        let indexPath = self.mainTable.indexPathForRow(at: point)
        if indexPath == nil {
            print("Long press on table view, not row.")
        } else if gestureRecognizer?.state == .began && indexPath?.section == 1 {
            let audio = audioViewModel.cells[indexPath!.row]
            self.initialActionSheet(title: audio.title, message: audio.artist, actions: self.getActions(at: indexPath!))
        }
    }
    
    @objc func willVKSearchBarOpened(_ notification: Notification) {
        UIView.animate(withDuration: 0.3, animations: {
            self.view.layoutIfNeeded()
        }) { _ in
        }
    }
    
    @objc func willVKSearchBarClosed(_ notification: Notification) {
        UIView.animate(withDuration: 0.3, animations: {
            self.view.layoutIfNeeded()
        })
    }
}
extension AudioViewController: UITableViewDelegate, UITableViewDataSource {
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return section == 0 ? 1 : audioViewModel.cells.count
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        if indexPath.section == 0 {
            let cell = tableView.dequeueReusableCell(withIdentifier: "AudioHeaderTableViewCell", for: indexPath) as! AudioHeaderTableViewCell
            cell.setupLayer()
            cell.selectionStyle = .none
            return cell
        } else {
            let cell = tableView.dequeueReusableCell(withIdentifier: "AudioTableViewCell", for: indexPath) as! AudioTableViewCell
            cell.setupCell(audio: audioViewModel.cells[indexPath.row])
            cell.selectionStyle = .none
            return cell
        }
    }
    
    func tableView(_ tableView: UITableView, shouldHighlightRowAt indexPath: IndexPath) -> Bool {
        let cell  = tableView.cellForRow(at: indexPath)
        cell!.contentView.backgroundColor = UIColor.adaptableGrayVK.withAlphaComponent(0.3)
        return true
    }

    func tableView(_ tableView: UITableView, didUnhighlightRowAt indexPath: IndexPath) {
        let cell  = tableView.cellForRow(at: indexPath)
        cell!.contentView.backgroundColor = .adaptableWhite
    }
    
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        return indexPath.section == 0 ? 52 : 60
    }
    
    func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath) {
        tableView.deselectRow(at: indexPath, animated: false)
        VKAudioService.instance.startMiniPlayer(title: audioViewModel.cells[indexPath.row].title, artist: audioViewModel.cells[indexPath.row].artist)
        switch VKAudioService.instance.player.state {
        case .ready :
            VKAudioService.instance.player.play(atIndex: indexPath.row)
        case .playing :
            if VKAudioService.instance.player.playIndex == indexPath.row {
                VKAudioService.instance.player.pause()
            } else {
                VKAudioService.instance.player.play(atIndex: indexPath.row)
            }
        case .paused :
            VKAudioService.instance.player.play()
        default:
            VKAudioService.instance.player.stop()
        }
    }
    
    func numberOfSections(in tableView: UITableView) -> Int {
        return 2
    }
}
extension AudioViewController {
    func getActions(at indexPath: IndexPath) -> [MDCActionSheetAction] {
        let audio = audioViewModel.cells[indexPath.row]
        let save = MDCActionSheetAction(title: "Сохранить", image: UIImage(named: "download_cloud_outline_28"), handler: { action in
            // presenter.onSave(audio: audio, at: indexPath)
            NotificationCenter.default.post(name: NSNotification.Name("onStartDownload"), object: nil, userInfo: ["indexPath" : indexPath])
        })
        let remove = MDCActionSheetAction(title: "Удалить", image: UIImage(named: "delete_outline_28"), handler: { action in
            self.initialFooter()
        })
        let removeFromStorage = MDCActionSheetAction(title: "Удалить из кэша", image: UIImage(named: "delete_outline_28")) { (action) in
            let documentsDirectoryURL = FileManager.default.urls(for: .documentDirectory, in: .userDomainMask).first!
            _ = documentsDirectoryURL.appendingPathComponent(URL(string: audio.url)!.lastPathComponent)
        }
        remove.titleColor = .extendedRed
        remove.tintColor = .extendedRed
        removeFromStorage.titleColor = .extendedRed
        removeFromStorage.tintColor = .extendedRed
        let documentsDirectoryURL = FileManager.default.urls(for: .documentDirectory, in: .userDomainMask).first!
        let destinationUrl = documentsDirectoryURL.appendingPathComponent(URL(string: audio.url)!.lastPathComponent)

        if FileManager.default.fileExists(atPath: destinationUrl.path) {
            return [removeFromStorage, remove]
        } else {
            return [save, remove]
        }
    }
}
extension AudioViewController: UITextFieldDelegate {
    func textField(textField: TextField, didChange text: String?) {
        guard textField == searchController.textView else { return }
        if textField.text == "" {
            UIView.animate(withDuration: 0.3, delay: 0, options: .transitionCrossDissolve, animations: {
                self.searchController.clearButton.alpha = 0
            }) { (isSuccess) in
                self.searchController.clearButton.isHidden = true
            }
        } else {
            self.searchController.clearButton.isHidden = false
            // self.searchTable.isHidden = false
            UIView.animate(withDuration: 0.3, delay: 0, options: .transitionCrossDissolve, animations: {
                self.searchController.clearButton.alpha = 1
            })
        }
    }

    func textFieldDidBeginEditing(_ textField: UITextField) {
        if textField == self.loginView.loginField {
            self.loginView.loginField.drawBorder(10, width: 1, color: .extendedBlue)
            self.loginView.loginField.backgroundColor = .adaptableField
        } else if textField == self.loginView.passwordField {
            self.loginView.passwordField.drawBorder(10, width: 1, color: .extendedBlue)
            self.loginView.passwordField.backgroundColor = .adaptableField
        } else {
            self.searchController.trailingConstraint?.constant = -104
            self.searchController.cancelButton.isHidden = false
            UIView.animate(withDuration: 0.3, delay: 0, options: .transitionCrossDissolve, animations: {
                self.searchController.cancelButton.alpha = 1
                self.searchController.layoutIfNeeded()
            })
            NotificationCenter.default.post(name: NSNotification.Name(rawValue: "VKSearchBar.beginEditing"), object: nil)
        }
    }
    
    func textFieldDidEndEditing(_ textField: UITextField) {
        if textField == self.loginView.loginField {
            self.loginView.loginField.drawBorder(10, width: 0.5, color: .adaptableBorder)
            self.loginView.loginField.backgroundColor = .adaptableField
        } else if textField == self.loginView.passwordField {
            self.loginView.passwordField.drawBorder(10, width: 0.5, color: .adaptableBorder)
            self.loginView.passwordField.backgroundColor = .adaptableField
        } else {
            self.searchController.trailingConstraint?.constant = -12
            self.searchController.textView.placeholderLabel.textColor = .adaptableDarkGrayVK
            UIView.animate(withDuration: 0.3, delay: 0, options: .transitionCrossDissolve, animations: {
                self.searchController.cancelButton.alpha = 0
                self.searchController.clearButton.alpha = 0
                self.searchController.layoutIfNeeded()
            }, completion: { _ in
                self.searchController.clearButton.isHidden = true
                self.searchController.cancelButton.isHidden = true
            })
            NotificationCenter.default.post(name: NSNotification.Name(rawValue: "VKSearchBar.endEditing"), object: nil)
        }
    }
    
    func textFieldDidChangeSelection(_ textField: UITextField) {
        if self.loginView.loginField.text!.isEmpty || self.loginView.passwordField.text!.isEmpty {
            //self.loginView.loginButton.isEnabled = false
            UIView.animate(withDuration: 0.2, delay: 0, options: .transitionCrossDissolve, animations: {
                self.loginView.loginButton.alpha = 0.4
            })
        } else {
            //self.loginView.loginButton.isEnabled = true
            UIView.animate(withDuration: 0.2, delay: 0, options: .transitionCrossDissolve, animations: {
                self.loginView.loginButton.alpha = 1
            })
        }
    }
}
extension AudioViewController {
    func registerKeyboardNotifications() {
        NotificationCenter.default.addObserver(self, selector: #selector(keyboardWillShow(_:)), name: UIResponder.keyboardWillShowNotification, object: nil)
        NotificationCenter.default.addObserver(self, selector: #selector(keyboardWillHide(_:)), name: UIResponder.keyboardWillHideNotification, object: nil)
    }
     
    @objc func keyboardWillShow(_ notification: NSNotification) {
        // adjustContentForKeyboard(shown: true, notification: notification)
    }
    
    @objc func keyboardWillHide(_ notification: NSNotification) {
        // adjustContentForKeyboard(shown: false, notification: notification)
    }
    
    func adjustContentForKeyboard(shown: Bool, notification: NSNotification) {
        guard let payload = KeyboardNotification(from: notification) else { return }
        if payload.event == .willShow {
            if self.loginView.containter.transform == .identity {
                let transfrom = CGAffineTransform.identity
                self.isKeyboardShow = true
                UIView.animate(withDuration: payload.timeInterval, delay: 0, options: payload.animationOptions, animations: {
                    self.loginView.containter.transform = transfrom.translatedBy(x: 0, y: -payload.endFrame.height - 44)
                    self.loginView.containter.layoutIfNeeded()
                })
            }
        } else {
            self.isKeyboardShow = false
            UIView.animate(withDuration: payload.timeInterval, delay: 0, options: payload.animationOptions, animations: {
                self.loginView.containter.transform = .identity
                self.loginView.containter.layoutIfNeeded()
            })
        }
    }
}
extension AudioViewController: MDCTabBarDelegate {
    func tabBar(_ tabBar: MDCTabBar, shouldSelect item: UITabBarItem) -> Bool {
        return tabBar.items.firstIndex(of: item) != 2
    }
    
    func tabBar(_ tabBar: MDCTabBar, didSelect item: UITabBarItem) {
        print("Item \(item.title!) was selected.")
    }
}
